package fr.janua.client.presenter;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.mvp4g.client.annotation.Presenter;
import com.mvp4g.client.presenter.BasePresenter;

import fr.janua.client.JaguardsEventBus;
import fr.janua.client.UserManager;
import fr.janua.client.internationalization.JaguardsConstants;
import fr.janua.client.view.MenuView;
import fr.janua.client.view.interfaces.IMenuView;
import fr.janua.client.view.interfaces.IMenuView.IMenuPresenter;
import fr.janua.shared.Action;

@Presenter(view = MenuView.class)
public class MenuPresenter extends BasePresenter<IMenuView, JaguardsEventBus> implements IMenuPresenter {
	
	private JaguardsConstants constants = GWT.create(JaguardsConstants.class);
	
	/* Calls EventBus*/
	
	public void onSetStatusConnection(String login, boolean isLogged) {
		view.setStatusConnection(login, isLogged);
	}
	
	
	
	/* Override */

	@Override
	public void logout() {
		eventBus.addLog(Action.DISCONNECTION, "logout (via bouton \"se déconnecter\")");
		UserManager.getInstance().setCurrentUser(null);
		eventBus.goToPageLogin();
		view.setStatusConnection("", false);
		
		// Signale une activité alors que le user est déconnecté. Permet de stoper le timer.
		eventBus.activity();
		
	}

	@Override
	public boolean isConnected() {
		if(UserManager.getInstance().getCurrentUser() != null){
			return true;
		}else{
			return false;
		}
	}


	@Override
	public void goToPageLogin() {
		eventBus.goToPageLogin();
	}
	

	// Onglet "Main Courante"
	@Override
	public void goToPageMainCourante() {
		eventBus.goToPageMainCourante();
	}

	// Onglet "Document"
	@Override
	public void goToPageDocument() {
		eventBus.goToPageDocument();
	}
	
	// Onglet "Administration"
	@Override
	public void goToPageProfil() {
		if(UserManager.getInstance().canAccessPageProfil())
			eventBus.goToPageUser();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}
	@Override
	public void goToPageAccessRights() {
		if(UserManager.getInstance().canAccessPageProfil())
			eventBus.goToPageGroup();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}
	@Override
	public void goToPageSite() {
		if(UserManager.getInstance().canAccessPageProfil())
			eventBus.goToPageSite();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}
	@Override
	public void goToPageType() {
		if(UserManager.getInstance().canAccessPageProfil())
			eventBus.goToPageType();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}
	@Override
	public void goToPageAdminDocument() {
		if(UserManager.getInstance().canAccessPageAdminDocument())
			eventBus.goToPageAdminDocument();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}
	@Override
	public void goToPageLog() {
		if(UserManager.getInstance().canAccessPageProfil())
			eventBus.goToPageLog();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}


	@Override
	public void goToPageDemo() {
		if(UserManager.getInstance().canAccessAdministration())
			eventBus.goToPageDemo();
		else
			Window.alert(constants.insufficientAccessRightsForAccessToThisPage());
	}



	








	

	


}