package fr.janua.client.stub;

import java.util.List;

import com.google.web.bindery.requestfactory.shared.Request;
import com.google.web.bindery.requestfactory.shared.RequestContext;
import com.google.web.bindery.requestfactory.shared.Service;

import fr.janua.client.proxy.UserProxy;
import fr.janua.server.dao.object.UserDAO;
import fr.janua.server.locator.DAOLocator;

@Service(value = UserDAO.class, locator = DAOLocator.class)
public interface UserRequest extends RequestContext {
	// méthodes génériques des DAO
	Request<Boolean> create(UserProxy user);
	Request<Boolean> delete(UserProxy user);
	Request<Boolean> update(UserProxy user);
	Request<UserProxy> findById(int id);
	
	// méthodes propres à cette DAO
	Request<UserProxy> findByLogin(String name);
	Request<List<UserProxy>> findAllUser();
	Request<List<String>> findAllLoginUser();
	Request<List<UserProxy>> findUser(int indexStart, int nbElement); 
	Request<Integer> getUserCount();
	Request<Boolean> checkAvailability(String login);
	Request<UserProxy> check(String login, String password);
	Request<UserProxy> checkWithEncryptedPaswword(String login, String password);
	Request<Boolean> isAdminExist();
	Request<Boolean> updateLastActivity(String login);

	
}
