package fr.janua.client.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiHandler;
import com.google.gwt.user.client.ui.Anchor;
import com.google.gwt.user.client.ui.Widget;
import com.google.inject.Singleton;

import fr.janua.client.internationalization.JaguardsConstants;
import fr.janua.client.view.interfaces.IMenuView;
import fr.janua.client.view.interfaces.IMenuView.IMenuPresenter;

/**
 * 
 * @author gilles
 *
 */
@Singleton
public class MenuView extends ReverseCompositeView<IMenuPresenter> implements IMenuView {
	private JaguardsConstants constants = GWT.create(JaguardsConstants.class);
	private static MenuViewUiBinder uiBinder = GWT.create(MenuViewUiBinder.class);


	@UiField
	Anchor anchor_logout;
	@UiField
	Anchor anchor_pageDemo;

	interface MenuViewUiBinder extends UiBinder<Widget, MenuView> {}
	public MenuView() {
		initWidget(uiBinder.createAndBindUi(this));
		// TODO : compléter cette page.
		// en prod : pas de page démo pour l'instant
		anchor_pageDemo.setVisible(false);
	}

	
	
	/* Override */
	
	@Override
	public void setStatusConnection(String login, boolean isLogged) {
		if(isLogged){
			anchor_logout.setText("(" + login + ") " + constants.disconnect());
		}else{
			anchor_logout.setText(constants.connect());
		}
	}
	
	/* Fonctions */
	

	
	
	
	/* Handlers */
	
	@UiHandler("anchor_logout")
	void onClickLogout(ClickEvent e){
		presenter.logout();
	}
	
	// Onglet "Home"
	@UiHandler("pageHome")
	void onClickPageHome(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageMainCourante();
		else
			presenter.goToPageLogin();
	}

	// Onglet "Main Courante"
	@UiHandler("anchor_pageMainCourante")
	void onClickPageAddMainCourante(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageMainCourante();
		else
			presenter.goToPageLogin();
	}
	
	//Onglet "Documents"
	@UiHandler("anchor_pageDocument")
	void onClickPageDocument(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageDocument();
		else
			presenter.goToPageLogin();
	}
	
	// Onglet "Administration"
	@UiHandler("anchor_pageProfil")
	void onClickPageProfil(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageProfil();
		else
			presenter.goToPageLogin();
	}
	@UiHandler("anchor_pageAccessRights")
	void onClickPageAccessRights(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageAccessRights();
		else
			presenter.goToPageLogin();
	}
	@UiHandler("anchor_pageType")
	void onClickPageType(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageType();
		else
			presenter.goToPageLogin();
	}
	@UiHandler("anchor_pageSite")
	void onClickPageSite(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageSite();
		else
			presenter.goToPageLogin();
	}
	@UiHandler("anchor_pageAdminDocument")
	void onClickPageAdminDocument(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageAdminDocument();
		else
			presenter.goToPageLogin();
	}
	
	@UiHandler("anchor_pageLog")
	void onClickPageLog(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageLog();
		else
			presenter.goToPageLogin();
	}

	@UiHandler("anchor_pageDemo")
	void onClickPageDemo(ClickEvent e){
		if(presenter.isConnected())
			presenter.goToPageDemo();
		else
			presenter.goToPageLogin();
	}
	
}
