package fr.janua.client.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.FormElement;
import com.google.gwt.dom.client.InputElement;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.UIObject;
import com.google.gwt.user.client.ui.Widget;

import fr.janua.client.UserManager;
import fr.janua.client.internationalization.JaguardsConstants;
import fr.janua.client.view.interfaces.IPageAdminDocumentView;
import fr.janua.client.view.interfaces.IPageAdminDocumentView.IPageAdminDocumentPresenter;

/**
 * 
 * @author Gilles Phan
 *
 */
public class PageAdminDocumentView extends ReverseCompositeView<IPageAdminDocumentPresenter> implements IPageAdminDocumentView {
	
	private JaguardsConstants constants = GWT.create(JaguardsConstants.class);
	private static PageAdminDocumentViewUiBinder uiBinder = GWT.create(PageAdminDocumentViewUiBinder.class);

	@UiField ListBox		lBox_section, lBox_language;
	@UiField FormElement	form_userManual;
	@UiField InputElement	input_loginUserManual;
	@UiField InputElement	input_passwordUserManual;
	@UiField InputElement	input_updateUserManual;
	
	
	interface PageAdminDocumentViewUiBinder extends UiBinder<Widget, PageAdminDocumentView> {}

	public PageAdminDocumentView() {
		initWidget(uiBinder.createAndBindUi(this));
	}
	
	/* Override */

	@Override
	public void createView() {
		// on choisit le texte "Mettre à jour" en fonction de la langue du navigateur
		input_updateUserManual.setAttribute("value", constants.update());
		
		lBox_section.addItem(constants.userManual(), "user_manual-");
		lBox_section.addItem(constants.securityGuide(), "security_guide-");
		lBox_section.addItem(constants.serviceRequest(), "service_request-");
		
		// Ajouter les langues en DUR ici !!
		lBox_language.addItem(constants.french(), "fr_FR");
		lBox_language.addItem(constants.english(), "en_US");
	}

	@Override
	public void loadPage() {

		// login
		input_loginUserManual.setValue(UserManager.getInstance().getLogin());
		
		// mot de passe
		input_passwordUserManual.setValue(UserManager.getInstance().getPassword());
		
		if(UserManager.getInstance().isEditableUploadDoc()){
			// visibilité des FormPanel
			UIObject.setVisible(form_userManual, true);
			
			
			
			
		}else{
			UIObject.setVisible(form_userManual, false);
		}
	}

	/* Fonction */
//	
//	private void generateSendFile(final FormPanel formPanel, final String nameFrame){
//		Frame frame = new Frame();
//		final Button buttonSubmit = new Button(constants.update());
//		final FileUpload fUpload = new FileUpload();
//
//		// initialisation du Frame
//		frame.setHeight("40px");
//		frame.setWidth("200px");
//		frame.getElement().setAttribute("frameBorder", "0");
//		frame.getElement().setAttribute("name", nameFrame);
//		
//		// initialisation du bouton de soumissions
//		buttonSubmit.setStyleName("padding-left-10 btn btn-info");
//		buttonSubmit.setVisible(false);
//		handlers.add(buttonSubmit.addClickHandler(new ClickHandler() {
//			@Override
//			public void onClick(ClickEvent event) {
////				Window.alert(fUpload.getFilename());
//				formPanel.submit();
////				if(nameFrame.equals(NAME_FRAME_USER_MANUAL)){
////					formPanel_userManual.submit();
////				}else if(nameFrame.equals(NAME_FRAME_SECURITY_GUIDE)){
////					formPanel_userManual.submit();
////				}else if(nameFrame.equals(NAME_FRAME_SERVICE_REQUEST)){
////					formPanel_userManual.submit();
////				}
//			}
//		}));
//		
//		// initialisation du FileUpload
//		fUpload.addStyleName("padding-right-10");
//		handlers.add(fUpload.addChangeHandler(new ChangeHandler() {
//			@Override
//			public void onChange(ChangeEvent event) {
//				buttonSubmit.setVisible(true);
//			}
//		}));
//		
//		
//		HorizontalPanel flowPanelWraper = new HorizontalPanel();
//		// ajout du FileUpload et du Button dans le FlowPanel
//		flowPanelWraper.add(fUpload);
//		flowPanelWraper.add(buttonSubmit);
////		flowPanelWraper.add(frame);
//		
//		formPanel.add(flowPanelWraper);
////		return result;
//	}
//	
	/* Handler */
}
