package fr.janua.client.view.interfaces;

import java.util.List;
import java.util.Set;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.view.LazyView;

import fr.janua.client.proxy.GroupProxy;
import fr.janua.client.proxy.SiteProxy;
import fr.janua.client.proxy.TypeProxy;

public interface IPageGroupView extends IsWidget , LazyView {
	public interface IPageGroupPresenter{

		/**
		 * Va récupérer tous les groupes dans la base de donnée.
		 */
		void getAllGroup();

		/**
		 * Crée un nouveau groupe.
		 * @param name
		 * @param mail
		 * @param setSite
		 * @param setType
		 * @param numCrudUser
		 * @param numCrudMessage
		 * @param numCrudGroup
		 * @param numCrudLog 
		 * @param numCrudType 
		 * @param numCrudSite 
		 * @param numCrudUploadDoc 
		 */
		void createGroup(String name, String mail, Set<SiteProxy> setSite, Set<TypeProxy> setType, int numCrudUser, int numCrudMessage, int numCrudGroup, int numCrudSite, int numCrudType, int numCrudLog, int numCrudUploadDoc);

		/**
		 * Met à jour le groupe.
		 * @param name
		 * @param mail
		 * @param setSite
		 * @param setType
		 * @param numCrudUser
		 * @param numCrudMessage
		 * @param numCrudGroup
		 * @param numCrudAdminDB 
		 */
		void updateGroup(String name, String mail, Set<SiteProxy> setSite, Set<TypeProxy> setType, int numCrudUser, int numCrudMessage, int numCrudGroup, int numCrudSite, int numCrudType, int numCrudLog, int numCrudAdminDB);
		
	}

	/**
	 * Fonction appelée à chaque fois que l'on va charger la page.
	 * @param name
	 */
	void loadPage();

	/**
	 * Affiche tous les Groupes dans le tableau.
	 * @param listGroup
	 */
	void displayGroups(List<SiteProxy> listSite, List<TypeProxy> listType, List<GroupProxy> listGroup);

	/**
	 * Envoie à la View la liste de tous les Types.
	 * @param listTypes
	 */
	void setListTypes(List<TypeProxy> listTypes);

	/**
	 * Envoie à la View la liste de tous les Sites.
	 * @param listSites
	 */
	void setListSites(List<SiteProxy> listSites);

}
