package fr.janua.client.view.interfaces;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.view.LazyView;

public interface IPageTypeView extends IsWidget , LazyView {
	public interface IPageTypePresenter{

		/**
		 * Envoie une requête pour récupérer la liste de tous les Types.
		 */
		void getAllType();

		/**
		 * Met à jour le Type passé en paramètre.
		 * @param typeUpdated
		 */
		void updateType(String name, String bgColor, String fgColor, boolean enabled);

		/**
		 * Créer un nouveau Type.
		 * @param newType
		 */
		void createType(String name, String bgColor, String fgColor, boolean enabled);
		
	}

	/**
	 * Fonction appelée à chaque fois que l'on va charger la page.
	 * @param name
	 */
	void loadPage();

	/**
	 * Affiche un Type : son nom, couleur de fond, couleur de texte, s'il est affichable et un bouton "Mettre à jour".
	 * @param type
	 */
	void displayOneType(String name, String bgColor, String fgColor, boolean enabled);

}
