package fr.janua.server;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import fr.janua.client.CrudService;
import fr.janua.server.utils.HibernateUtils;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class CrudServiceImpl extends RemoteServiceServlet implements CrudService {

	@Override
	public boolean changeConfigDB(String host, String user, String password, String tableName) {
		return HibernateUtils.changeConfig(host, tableName, user, password);
	}

	@Override
	public boolean checkDB() {
		return HibernateUtils.checkConnection();
	}

	@Override
	public String[] getConfigDB() {
		String[] tabConfig = new String[2];
		tabConfig[0] = HibernateUtils.getUrl();
		tabConfig[1] = HibernateUtils.getUsername();
		return tabConfig;
	}

	@Override
	public void reloadConfDB() {
		HibernateUtils.reloadConf();
	}

}
