package fr.janua.server.dao;

import fr.janua.server.dao.object.CommentDAO;
import fr.janua.server.dao.object.GroupDAO;
import fr.janua.server.dao.object.LogDAO;
import fr.janua.server.dao.object.MessageDAO;
import fr.janua.server.dao.object.SiteDAO;
import fr.janua.server.dao.object.TypeDAO;
import fr.janua.server.dao.object.UserDAO;

public class DAOFactory {

	/**
	 * Retourne un objet UserDAO, interagissant avec la BDD
	 * @return
	 */
	public static UserDAO getUserDAO(){
		return new UserDAO();
	}
	
	/**
	 * Retourne un objet GroupDAO, interagissant avec la BDD
	 * @return
	 */
	public static GroupDAO getGroupDAO(){
		return new GroupDAO();
	}

	/**
	 * Retourne un objet SiteDAO, interagissant avec la BDD
	 * @return
	 */
	public static SiteDAO getSiteDAO(){
		return new SiteDAO();
	}
	
	/**
	 * Retourne un objet TypeDAO, interagissant avec la BDD
	 * @return
	 */
	public static TypeDAO getTypeDAO(){
		return new TypeDAO();
	}

	/**
	 * Retourne un objet MessageDAO, interagissant avec la BDD
	 * @return
	 */
	public static MessageDAO getMessageDAO(){
		return new MessageDAO();
	}
	
	/**
	 * Retourne un objet ComplementaryMessageDAO, interagissant avec la BDD
	 * @return
	 */
	public static CommentDAO getCommentDAO(){
		return new CommentDAO();
	}

	/**
	 * Retourne un objet LogDAO, interagissant avec la BDD
	 * @return
	 */
	public static LogDAO getLogDAO(){
		return new LogDAO();
	}
}
