package fr.janua.server.dao.object;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import fr.janua.server.dao.DAO;
import fr.janua.server.entity.Comment;
import fr.janua.server.utils.HibernateUtils;

public class CommentDAO extends DAO<Comment>{

	public CommentDAO() {
		super();
	}

	@Override
	public boolean create(Comment cm) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.save(cm);
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public boolean delete(Comment cm) {
		// TODO : à coder
		return false;
	}

	@Override
	public boolean update(Comment cm) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.update(cm);
			tx.commit();
		}catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public Comment findById(int id) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Query query = session.createQuery("SELECT c FROM Comment c WHERE c.id = :id");
		query.setParameter("id", id);
		Comment message = (Comment) query.uniqueResult();
		session.close();
		
		return message;
	}

}
