package fr.janua.server.dao.object;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import fr.janua.server.dao.DAO;
import fr.janua.server.entity.Type;
import fr.janua.server.utils.HibernateUtils;

public class TypeDAO extends DAO<Type>{

	public TypeDAO() {
		super();
	}

	@Override
	public boolean create(Type type) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.save(type);
			tx.commit();
			System.out.println("[Type] create(" + type.getName()  + ") : ok");
		} catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			System.out.println("[Type] create(" + type.getName()  + ") : not ok !!");
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public boolean delete(Type type) {
		// TODO : à coder
		return false;
	}

	@Override
	public boolean update(Type type) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.update(type);
			tx.commit();
		}catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public Type findById(int id) {
		System.err.println("Type n'a pas d'id. Utiliser la fonction finByName !");
		return null;
	}
	
	public Type findByName(String name) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Query query = session.createQuery("SELECT type FROM Type type WHERE type.name = :name");
		query.setParameter("name", name);
		Type type = (Type) query.uniqueResult();
		session.close();

		return type;
	}

	/**
	 * Récupère tous les Types de la base de donnée.
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public List<Type> findAllType() {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Query query = session.createQuery("SELECT type FROM Type type");
		List<Type> list = query.list();
		session.close();
		
		return list;
	}

}
