package fr.janua.server.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Version;


@Entity(name = "Type")
@Table(name = "t_type")
public class Type {
	
	@Id
	@Column(name="type_name")
	private String name;
	
	@Column(name="type_bg_color")
	private String bgColor;
	
	@Column(name="type_fg_color")
	private String fgColor;

	@Column(name="type_enabled")
	private boolean enabled;
	
	@Version
	@Column(name = "type_version")
//	@NotNull
	private Integer version;
	
	
	
	/* Constructeurs */

	/**
	 * Constructeur vide.
	 */
	public Type() {}

	/**
	 * Constructeur par défaut de la classe Type.
	 * @param name
	 * @param bgColor
	 * @param fgColor
	 * @param enabled
	 * @param version
	 */
	public Type(String name, String bgColor, String fgColor,
			boolean enabled, Integer version) {
		this.name = name;
		this.bgColor = bgColor;
		this.fgColor = fgColor;
		this.enabled = enabled;
		this.version = version;
	}

	
	
	
	/* Accesseurs / Mutateurs */
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the bgColor
	 */
	public String getBgColor() {
		return bgColor;
	}

	/**
	 * @param bgColor the bgColor to set
	 */
	public void setBgColor(String bgColor) {
		this.bgColor = bgColor;
	}

	/**
	 * @return the fgColor
	 */
	public String getFgColor() {
		return fgColor;
	}

	/**
	 * @param fgColor the fgColor to set
	 */
	public void setFgColor(String fgColor) {
		this.fgColor = fgColor;
	}

	/**
	 * @return the enabled
	 */
	public boolean isEnabled() {
		return enabled;
	}

	/**
	 * @param enabled the enabled to set
	 */
	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}

	/**
	 * @return the version
	 */
	public Integer getVersion() {
		return version;
	}

	/**
	 * @param version the version to set
	 */
	public void setVersion(Integer version) {
		this.version = version;
	}

	
	
	
	@Override
	public String toString() {
		return "Type [name=" + name + ", bgColor=" + bgColor
				+ ", fgColor=" + fgColor + ", enabled=" + enabled
				+ ", version=" + version + "]";
	}
	
	
	

	
	
}
