package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.CommentDAO;
import fr.janua.server.entity.Comment;

public class CommentLocator extends Locator<Comment, Integer> {

	@Override
	public Comment create(Class<? extends Comment> clazz) {
		return new Comment();
	}

	@Override
	public Comment find(Class<? extends Comment> clazz, Integer id) {
		return getCommentDao().findById(id);
	}

	@Override
	public Class<Comment> getDomainType() {
		return Comment.class;
	}

	@Override
	public Integer getId(Comment domainObject) {
		return domainObject.getId();
	}

	@Override
	public Class<Integer> getIdType() {
		return Integer.class;
	}

	@Override
	public Object getVersion(Comment domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère le CommentDAO.
	 * 
	 * @return
	 */
	private CommentDAO getCommentDao() {
		return DAOFactory.getCommentDAO();
	}
}
