package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.UserDAO;
import fr.janua.server.entity.User;

public class UserLocator extends Locator<User, String> {

	@Override
	public User create(Class<? extends User> clazz) {
		return new User();
	}

	@Override
	public User find(Class<? extends User> clazz, String id) {
		return getUserDao().findByLogin(id);
	}

	@Override
	public Class<User> getDomainType() {
		return User.class;
	}

	@Override
	public String getId(User domainObject) {
		return domainObject.getLogin();
	}

	@Override
	public Class<String> getIdType() {
		return String.class;
	}

	@Override
	public Object getVersion(User domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère l'UserDAO.
	 * 
	 * @return
	 */
	private UserDAO getUserDao() {
		return DAOFactory.getUserDAO();
	}
}
