package fr.janua.shared;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import com.google.gwt.user.client.rpc.IsSerializable;

@Entity(name = "Log")
@Table(name = "t_log")
public class Log implements Serializable, IsSerializable{

	private static final long serialVersionUID = 2934198105279662628L;

	@Id
	@Column(name="log_id")
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private int id;
	
	@Column(name="log_login_author", length=40)
	private String loginAuthor;

	@Column(name="log_action")
	private String action;

	@Column(name="log_detail")
	private String detail;
	
	@Column(name="log_date")
	private long date;
	
	@Column(name="log_ip", length=15)
	private String ip;
	
	/* Constructeurs */
	
	public Log() {}
	/**
	 * 
	 * @param loginAuthor
	 * @param action
	 * @param detail
	 * @param date
	 */
	public Log(String loginAuthor, String action, String detail, long date, String ip) {
		this.loginAuthor = loginAuthor;
		this.action = action;
		this.detail = detail;
		this.date = date;
		this.ip = ip;
	}
	
	/* Accesseurs / Mutateurs */
	/**
	 * @return the loginAuthor
	 */
	public String getLoginAuthor() {
		return loginAuthor;
	}
	/**
	 * @param loginAuthor the loginAuthor to set
	 */
	public void setLoginAuthor(String loginAuthor) {
		this.loginAuthor = loginAuthor;
	}
	/**
	 * @return the action
	 */
	public String getAction() {
		return action;
	}
	/**
	 * @param action the action to set
	 */
	public void setAction(String action) {
		this.action = action;
	}
	/**
	 * @return the detail
	 */
	public String getDetail() {
		return detail;
	}
	/**
	 * @param detail the detail to set
	 */
	public void setDetail(String detail) {
		this.detail = detail;
	}
	/**
	 * @return the date
	 */
	public long getDate() {
		return date;
	}
	/**
	 * @param date the date to set
	 */
	public void setDate(long date) {
		this.date = date;
	}
	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}
	/**
	 * @return the ip
	 */
	public String getIp() {
		return ip;
	}
	/**
	 * @param ip the ip to set
	 */
	public void setIp(String ip) {
		this.ip = ip;
	}

	
	
	public String toString() {
		return "Log [id=" + id + ", loginAuthor=" + loginAuthor + ", action="
				+ action + ", detail=" + detail + ", date=" + date + ", ip="
				+ ip + "]";
	}
	
	
	
	
	
	
	
}
